OPTIONS NODATE obs=max;
proc dbf db4=treedat2 out=a;
proc dbf db4=holldat2 out=b;

data holl; set b;
if width = 0 then width = .;
if width=. then width=2.47 + (entw*.72);
if depth = 0 then depth = .;
if back = 0 then back = .;
if tdhol = 0 then tdhol = .;

if entw lt 10.5 then delete; if entw gt 40 then delete;
if ht lt 14.3 then delete;
if width lt 14 then delete; if width gt 40 then delete;


btp = 1;

proc sort; by stand trans num; run;
proc means noprint; by stand trans num; var btp;
  output out = new sum = hol; run;

proc sort data = a; by stand trans num; run;

data c; merge new a; by stand trans num;
proc sort; by stand trans uncut;
proc means noprint; by stand trans uncut; var hol;
  output out = new2 sum = allhol; run;
data d; set new2;
size = 0.2;
if stand = 4 and trans  = 1 then size = 0.4;
if stand = 4 and trans  = 2 then size = 0.4;
if stand = 5 then size = 0.4;
if stand = 6 then size = 0.4;
if stand = 7 then size = 0.4;
if stand = 9 then size = 0.4;
if allhol = . then allhol = 0;
holldens = allhol / size;
proc print; var stand trans allhol holldens size; run;
title 'hollow densities per ha for corellas in cut and uncut trees';
proc sort; by uncut; run;
proc means n mean stderr min max; var holldens; by uncut; run;
