OPTIONS NODATE obs=max;
proc dbf db4=treedat2 out=a;
proc dbf db4=holldat2 out=b;

data holl; set b;
if width = 0 then width = .;
if width=. then width=2.47 + (entw*.72);
if depth = 0 then depth = .;
if back = 0 then back = .;
if tdhol = 0 then tdhol = .;
if entw lt 6 then delete; if entw gt 49 then delete;
if ht lt 0.5 then delete;
if width lt 8 then delete; if width gt 48 then delete;
btp = 1;
proc sort; by stand trans num; run;

data c; set a;
if dbhob=0 then dbhob=0.230+(stump*.89);
area = (3.1416*((dbhob / 2)**2));
if ht12 = 0 then ht12 = ht11 + .2;
if ht22 = 0 then ht22 = ht21 + .2;
if ht32 = 0 then ht32 = ht31 + .2;
if qual1 = 'R' or qual1 = 'RT' then rotamt1 = ht12 - ht11;
if qual2 = 'R' or qual2 = 'RT' then rotamt2 = ht22 - ht21;
if qual3 = 'R' or qual3 = 'RT' then rotamt3 = ht32 - ht31;
if rotamt1 = . then rotamt1 = 0;
if rotamt2 = . then rotamt2 = 0;
if rotamt3 = . then rotamt3 = 0;
if qual1 = 'R' or qual1 = 'RT' then rotqnt1 = quant1*area;
if qual2 = 'R' or qual2 = 'RT' then rotqnt2 = quant2*area;
if qual3 = 'R' or qual3 = 'RT' then rotqnt3 = quant3*area;
if rotqnt1 = . then rotqnt1 = 0;
if rotqnt2 = . then rotqnt2 = 0;
if rotqnt3 = . then rotqnt3 = 0;
rotvol = (rotamt1*rotqnt1) + (rotamt2*rotqnt2) + (rotamt3*rotqnt3);
rotamt = rotamt1 + rotamt2 + rotamt3;

if qual1 = 'H' or qual1 = 'HB' then holamt1 = ht12 - ht11;
if qual2 = 'H' or qual2 = 'HB' then holamt2 = ht22 - ht21;
if qual3 = 'H' or qual3 = 'HB' then holamt3 = ht32 - ht31;
if qual1 = 'HM' or qual1 = 'HP' then holamt1 = ht12 - ht11;
if qual2 = 'HM' or qual2 = 'HP' then holamt2 = ht22 - ht21;
if qual3 = 'HM' or qual3 = 'HP' then holamt3 = ht32 - ht31;
if holamt1 = . then holamt1 = 0;
if holamt2 = . then holamt2 = 0;
if holamt3 = . then holamt3 = 0;
if qual1 = 'H' or qual1 = 'HB' then holqnt1 = quant1*area;
if qual2 = 'H' or qual2 = 'HB' then holqnt2 = quant2*area;
if qual3 = 'H' or qual3 = 'HB' then holqnt3 = quant3*area;
if qual1 = 'HM' or qual1 = 'HP' then holqnt1 = quant1*area;
if qual2 = 'HM' or qual2 = 'HP' then holqnt2 = quant2*area;
if qual3 = 'HM' or qual3 = 'HP' then holqnt3 = quant3*area;
if holqnt1 = . then holqnt1 = 0;
if holqnt2 = . then holqnt2 = 0;
if holqnt3 = . then holqnt3 = 0;
holvol = (holamt1*holqnt1) + (holamt2*holqnt2) + (holamt3*holqnt3);
holamt = holamt1 + holamt2 + holamt3;

if qual1 = 'BU' or qual1 = 'BW' then buamt1 = ht12 - ht11;
if qual2 = 'BU' or qual2 = 'BW' then buamt2 = ht22 - ht21;
if qual3 = 'BU' or qual3 = 'BW' then buamt3 = ht32 - ht31;
if buamt1 = . then buamt1 = 0;
if buamt2 = . then buamt2 = 0;
if buamt3 = . then buamt3 = 0;
if qual1 = 'BU' or qual1 = 'BW' then buqnt1 = quant1*area;
if qual2 = 'BU' or qual1 = 'BW' then buqnt2 = quant2*area;
if qual3 = 'BU' or qual1 = 'BW' then buqnt3 = quant3*area;
if buqnt1 = . then buqnt1 = 0;
if buqnt2 = . then buqnt2 = 0;
if buqnt3 = . then buqnt3 = 0;
buvol = (buamt1*buqnt1) + (buamt2*buqnt2) + (buamt3*buqnt3);
buamt = buamt1 + buamt2 + buamt3;

if qual1 = 'RT' or qual1 = 'T' then tmamt1 = ht12 - ht11;
if qual2 = 'RT' or qual2 = 'T' then tmamt2 = ht22 - ht21;
if qual3 = 'RT' or qual3 = 'T' then tmamt3 = ht32 - ht31;
if tmamt1 = . then tmamt1 = 0;
if tmamt2 = . then tmamt2 = 0;
if tmamt3 = . then tmamt3 = 0;
if qual1 = 'RT' or qual1 = 'T' then tmqnt1 = quant1*area;
if qual2 = 'RT' or qual1 = 'T' then tmqnt2 = quant2*area;
if qual3 = 'RT' or qual1 = 'T' then tmqnt3 = quant3*area;
if tmqnt1 = . then tmqnt1 = 0;
if tmqnt2 = . then tmqnt2 = 0;
if tmqnt3 = . then tmqnt3 = 0;
tmvol = (tmamt1*tmqnt1) + (tmamt2*tmqnt2) + (tmamt3*tmqnt3);
tmamt = tmamt1 + tmamt2 + tmamt3;

if qual1 = 'D' or qual1 = 'DB' then dryamt1 = ht12 - ht11;
if qual2 = 'D' or qual2 = 'DB' then dryamt2 = ht22 - ht21;
if qual3 = 'D' or qual3 = 'DB' then dryamt3 = ht32 - ht31;
if qual1 = 'DM' or qual1 = 'DP' then dryamt1 = ht12 - ht11;
if qual2 = 'DM' or qual2 = 'DP' then dryamt2 = ht22 - ht21;
if qual3 = 'DM' or qual3 = 'DP' then dryamt3 = ht32 - ht31;
if qual1 = 'DW' then dryamt1 = ht12 - ht11;
if qual2 = 'DW' then dryamt2 = ht22 - ht21;
if qual3 = 'DW' then dryamt3 = ht32 - ht31;
if dryamt1 = . then dryamt1 = 0;
if dryamt2 = . then dryamt2 = 0;
if dryamt3 = . then dryamt3 = 0;
if qual1 = 'D' or qual1 = 'DB' then dryqnt1 = quant1*area;
if qual2 = 'D' or qual2 = 'DB' then dryqnt2 = quant2*area;
if qual3 = 'D' or qual3 = 'DB' then dryqnt3 = quant3*area;
if qual1 = 'DM' or qual1 = 'DP' then dryqnt1 = quant1*area;
if qual2 = 'DM' or qual2 = 'DP' then dryqnt2 = quant2*area;
if qual3 = 'DM' or qual3 = 'DP' then dryqnt3 = quant3*area;
if qual1 = 'DW' then holqnt1 = quant1*area;
if qual2 = 'DW' then holqnt2 = quant2*area;
if qual3 = 'DW' then holqnt3 = quant3*area;
if dryqnt1 = . then dryqnt1 = 0;
if dryqnt2 = . then dryqnt2 = 0;
if dryqnt3 = . then dryqnt3 = 0;
dryvol = (dryamt1*dryqnt1) + (dryamt2*dryqnt2) + (dryamt3*dryqnt3);
dryamt = dryamt1 + dryamt2 + dryamt3;
defvol = dryvol + tmvol + holvol+ rotvol + buvol;
defamt = dryamt + tmamt + holamt + rotamt + buamt;

proc sort; by stand trans num sp silv; run;
proc means noprint; by stand trans num sp silv; var dbhob bole rotamt holamt buamt tmamt
dryamt defamt
rotvol holvol buvol tmvol dryvol defvol uncut; output out = new

sum = dbh bol rotam holam buam tmam dryam defam
rotall holall buall tmall dryall defall uncut

mean = mdbh mbol mrotam mholam mbuam mtmam mdryam mdefam
mrotall mholall mbuall mtmall mdryall mdefall muncut; run;

proc sort data = new; by stand trans num; run;

data all; merge new holl; by stand trans num;
if muncut ge 1 then delete;
if sp = 5 then sp = 0;
if silv=4 or silv = 5 or silv = 6 then cl=0;
if silv = 2 or silv = 1 then cl = 1;
if silv = 3 then cl = 2;
if btp = . then btp = 0;
if stand = 1 then precip = 1050;
if stand = 2 then precip = 950;
if stand = 3 then precip = 950;
if stand = 4 then precip = 850;
if stand = 5 then precip = 850;
if stand = 6 then precip = 1050;
if stand = 7 then precip = 800;
if stand = 8 then precip =  875;
if stand = 9 then precip = 1150;

proc freq; tables cl*btp; run;

proc LOGISTIC; MODEL btp= precip cl sp
mdbh mbol mrotam mholam mbuam mtmam mdryam mdefam
mrotall mholall mbuall mtmall mdryall mdefall/selection = stepwise; run;

proc sort; by sp; run;
proc ttest; by sp; class btp; var
precip cl
mdbh mbol mrotam mholam mbuam mtmam mdryam mdefam
mrotall mholall mbuall mtmall mdryall mdefall; run;
